<template>
  <div>
    <div class="header-page">
      <div class="header-page-left">{{ $t('balances.title')}}</div>
      <div class="header-page-right">
        <router-link tag="span" to="/deposit">
          {{ $t('balances.deposit')}}
          <span class="iconmo-download"></span>
        </router-link>
      </div>
    </div>
    <div class="estimate-box">
      <div class="estimated-value">{{ $t('balances.estimated') }}</div>
      <div class="estimated-value-USDT">
        {{ totalUsdValue | formatCurrencyAmount('usd', '0') }} <span class="unit">USD</span>
      </div>
      <div class="estimated-value-HETA">
        {{ totalHetaTokensValue | formatCurrencyAmount('heta', '0') }} <span class="unit">HETA Tokens</span>
      </div>
    </div>
    <div class="wallet-table">
      <div class="wallet-table-row" v-for="wallet in wallets" :key="wallet.id">
        <router-link v-if="wallet.currency === 'heta'" to="/">
          <div class="currency">
            <img :src="`/images/icon/balanceImg/heta-${wallet.currency}-icon.png`"
                 :alt="wallet.currency" class="coin__image">
            <span class="coin__name">{{ wallet.currency | uppercase }}</span>
            <span class="coin__fullname">({{ getCoinFullName(wallet.currency) }})</span>
          </div>
          <div class="wallet">
            {{ wallet.balance | formatCurrencyAmount(wallet.currency, '0') }}
          </div>
        </router-link>
        <router-link v-else :to="{ path: 'deposit', query: { currency: wallet.currency }}">
          <div class="currency">
            <img :src="`/images/icon/balanceImg/heta-${wallet.currency}-icon.png`"
                 :alt="wallet.currency" class="coin__image">
            <span class="coin__name">{{ wallet.currency | uppercase }}</span>
            <span class="coin__fullname">({{ getCoinFullName(wallet.currency) }})</span>
          </div>
          <div class="wallet">
            {{ wallet.balance | formatCurrencyAmount(wallet.currency, '0') }}
          </div>
        </router-link>
      </div>
    </div>
  </div>
</template>

<script>
  import { mapState, mapGetters } from 'vuex';
  import BigNumber from 'bignumber.js';

  export default {
    data () {
      return {
        coins: {
          btc: {
            name: "BTC",
            fullname: "Bitcoin",
          },
          eth: {
            name: "ETH",
            fullname: "Ethereum",
          },
          usdt: {
            name: "USDT",
            fullname: "Tether USDT",
          },
          heta: {
            name: "HETA",
            fullname: "Heta Token",
          }
        }
      }
    },
    watch: {
      wallets () {
        this.updateInternalWallets();
      },
      prices () {
        this.updateInternalWallets();
      },
    },
    computed: {
      totalUsdValue () {
        return this.getEstimateTotalValue('usd');
      },
      totalHetaTokensValue () {
        return this.getEstimateTotalValue('heta');
      },
      ...mapState(['wallets', 'prices']),
      ...mapGetters(['getPrecision']),
    },
    methods: {
      getCoinFullName (coin) {
        if (!this.coins[coin]) {
          return '';
        }
        return this.coins[coin].fullname;
      },

      getEstimateTotalValue (currency) {
        let total = BigNumber('0');
        _.forEach(this.wallets, wallet => {
          if (BigNumber(wallet.balance).comparedTo(0) > 0) {
            let est = BigNumber(this.getEstimateValue(wallet.balance, wallet.currency, currency)).toFixed(this.getPrecision(currency), BigNumber.ROUND_DOWN);
            total = total.plus(est);
          }
        });

        return total.toString();
      },

      getEstimateValue (amount, coin, currency) {
        if (currency === 'usd') {
          return BigNumber(`${amount}`).multipliedBy(this.getRate(coin, currency)).toString();
        }

        const rate = BigNumber(this.getRate(currency, coin)).toFixed(this.getPrecision(coin), BigNumber.ROUND_UP);
        return BigNumber(`${amount}`).div(rate).toString();
      },

      getRate (coin, currency) {
        if (currency === 'usd') {
          return this.getPrice(coin);
        }

        if (BigNumber(this.getPrice(currency)).isZero()) {
          return '0';
        }

        return BigNumber(this.getPrice(coin)).div(this.getPrice(currency)).toString()
      },

      getPrice (coin) {
        if (!this.prices[coin]) {
          return '0';
        }

        return `${this.prices[coin] || 0}`;
      },

      toNumber (amount, round = 10) {
        const newAmount = BigNumber(`${amount}`).toFixed(round);
        return BigNumber(`${newAmount}`).toNumber();
      },

      updateInternalWallets () {
        _.forEach(this.wallets, wallet => {
          wallet.usd_value = this.toNumber(this.getEstimateValue(wallet.balance, wallet.currency, 'usd'));
          wallet.heta_value = this.toNumber(this.getEstimateValue(wallet.balance, wallet.currency, 'heta'));
        });
      },
    },
  }
</script>

<style lang="scss" scoped>
  @import "../../../sass/mobile/typoVariables.scss";

  .header-page {
    font-size: 0;
    width: 100%;
    background-image: linear-gradient(to bottom, $midnight, $catalina_blue);
    box-shadow: 0 2rem 40rem 0 rgba(0, 0, 0, 0.5);
    color: white;
    margin: 0rem;
    padding: 13rem 0;

    &.row {
      margin: 0rem;
    }
  }

  .header-page-left {
    font-size: 18rem;
    color: $white;
    width: 60%;
    padding-left: 12rem;
    display: inline-block;
  }

  .header-page-right {
    @extend .Medium-14;
    width: 40%;
    color: #cacaca;
    line-height: initial;
    padding-right: 12rem;
    display: inline-block;
    position: relative;
    text-align: right;

    .iconmo-download {
      // position: absolute;
      // right: 11rem;
      // font-size: 11rem;
      // top: 30rem;
    }
  }

  .estimate-box {
    width: 100%;
    height: 115rem;
    background-color: #da6400;
    padding: 16rem 10rem 25rem 13rem;

    .unit {
      padding-left: 2rem;
      letter-spacing: 0.4rem;
      text-transform: initial;
    }
  }

  .estimated-value {
    @extend .Medium-14;
    width: 100%;
    line-height: normal;
    letter-spacing: 0;
    color: white;
    height: 16rem;
    margin-bottom: 10rem;
  }

  .estimated-value-USDT {
    @extend .bold--18;
    width: 100%;
    height: 21rem;
    color: white;
    letter-spacing: 0;
    text-transform: uppercase;
    margin-bottom: 4rem;
  }

  .estimated-value-HETA {
    @extend .bold--18;
    width: 100%;
    height: 21rem;
    color: white;
    letter-spacing: 0;
    text-transform: uppercase;
  }

  .wallet-table {
    width: 100%;
    height: calc(100vh - 543rem);
    min-height: 301rem;
    background: $bg_primary;
    padding: 15rem 15rem 15rem 12rem;
  }

  .wallet-table-row {
    border-bottom: 1rem solid #e0e0e0;
    min-height: 50rem;

    .currency {
      display: inline-block;
      width: 66.25%;
    }

    .wallet {
      @extend .bold-14;
      display: inline-block;
      color: #1c1c1c;
      font-weight: 700;
    }

    .coin__image {
      width: 20rem;
      height: 20rem;
      margin-right: 3rem;
      position: relative;
      top: -4rem;
    }

    .coin__fullname {
      @extend .Medium-14;
      color: #989898;
      margin-left: 4rem;
    }

    .coin__name {
      @extend .Medium-14;
      font-weight: bold;
      color: #1c1c1c;
      letter-spacing: 1.5rem;
    }
  }
</style>
